; Program pro LCD display regultoru topen V1.0
PCON	DATA	87H
TMOD	DATA	89H
P1	DATA	90H
TCONB	DATA	91H
RL0	DATA	92H
RL1	DATA	93H
RH0	DATA	94H
RH1	DATA	95H
SCON	DATA	98H
SBUF	DATA	99H
P3	DATA	0B0H
P1M0	DATA	0C2H
P1M1	DATA	0C3H
P3M0	DATA	0C6H
P3M1	DATA	0C7H
ACC	DATA	0E0H
B	DATA	0F0H

TR1	BIT	8EH
RI	BIT	98H
ES	BIT	0ACH
EA	BIT	0AFH

RESETADDR	EQU	0000H
SERADDR	EQU	0023H
E	equ	P3.7
RS	equ	P3.5
CISLO equ	40H
RADEK1 equ	50H		;1.datov dek
RADEK2 equ	60H		;2.datov dek
SDATA	equ 31H		;buffer pro zpravu
SMAX	equ 6			;dlka dat
KONEC_PRIJMU BIT 1	;nvrat na zatek cyklu
PREP BIT 2
SKONST EQU 65484		;pro 9600 Bd

	ORG RESETADDR	;reset
	JMP RESET	
	ORG SERADDR		;obsluha UART
	JMP SERIAL	

RESET:	;nastaven:	
	MOV P1M0,#00000000B	;P1 vstupy
	MOV P1M1,#11111111B	;
	MOV P3M0,#00000001B	;P3 vstupy
	MOV P3M1,#11111110B	;P3.0 vstup RxD
	mov	P1,#255
	mov	P3,#255
	MOV TMOD,#00010001B	;16b asova 0 a 1
	SETB TR1			;spus asova 1
	MOV RL1,#LOW SKONST	;nastav penos.
	MOV RH1,#HIGH SKONST	;rychlost
	MOV SCON,#01010000B	;8b async. reim+povolen pjmu
	MOV PCON,#00000000B	;SMOD1=0
	SETB EA			;uvolni peruen
	SETB ES			;povol peruen od UART
	mov R5,#2			;nastav as zmeny zobrazeni LCD x1s
	mov	RADEK1+2,#223	;(stupe celsia)
	mov	RADEK1+3,#67	;C
	mov	RADEK1+4,#32	;mezera ASCII
	mov	RADEK1+5,#32	;mezera ASCII
	mov	RADEK1+8,#223	;(stupe celsia)
	mov	RADEK1+9,#67	;C
	mov	RADEK1+10,#32	;mezera ASCII
	mov	RADEK1+11,#32	;mezera ASCII
	mov	RADEK1+14,#223	;(stupe celsia)
	mov	RADEK1+15,#67	;C
	mov	RADEK2,#32	      ;mezera ASCII
	mov	RADEK2+1,#32	;mezera ASCII
	mov	RADEK2+2,#32	;mezera ASCII
	mov	RADEK2+3,#32	;mezera ASCII
	mov	RADEK2+4,#32	;mezera ASCII
	mov	RADEK2+5,#32	;mezera ASCII
	mov	RADEK2+6,#32	;mezera ASCII
	mov	RADEK2+9,#223	;(stupe celsia)
	mov	RADEK2+10,#67	;C
	mov	RADEK2+11,#32	;mezera ASCII
	mov	RADEK2+14,#223	;(stupe celsia)
	mov	RADEK2+15,#67	;C
	clr	E
	clr 	KONEC_PRIJMU
	mov	b,#150		;x100 us
	call	Delay			;zpozdeni nez disp. po pripojeni napajeni muze 						 prijimat data
	;inicializace
	mov	a,#00111000b	;8-bit mod, font 5x7 a dvouradkovy disp.
	mov	b,#1			;nastaven prodlevy 40uS
	acall	PosliInstr
	mov	a,#00000110b	;posuv kurzoru vpravo, a text se neposouva
	mov	b,#1
	acall	PosliInstr
	mov	a,#00001100b	;zapnout disp., vypnout kurzor
	mov	b,#1
	acall	PosliInstr
	mov	a,#00000001b	;smaz displej a vrat kurzor na zacatek
	mov	b,#17			;nastaven prodlevy 1,64mS
	acall	PosliInstr

	;psani uvodniho textu
	mov	a,#10000000b	;nastav 1.radek,1.sloupec
	mov	b,#1
	acall	PosliInstr
	mov	dptr,#Text0	;ukazatel na zacatek textu 0
	mov	R7,#0			;nulovat ukazatel znaku
Text0dalsi:	mov	a,R7
	movc	a,@a+dptr		;nacti znak z pozice R7
	jz	Text0OK		;jestli je znak 0, tak je text kompletni
	mov	b,#1
	acall	PosliData
	inc	R7			;dalsi znak
	jmp	Text0dalsi		;pis dalsi
Text0OK:	

SMYCKA:
	MOV R1,#0			;vynuluj potadlo byt
	MOV R0,#SDATA		;adresa SDATA do R0
	JNB KONEC_PRIJMU,$	;cel zprva = zobrazen dat
	CLR KONEC_PRIJMU		;vynuluj pznak konce pjmu
	djnz R5,TED_NE
	mov R5,#2			;nastav as x1s
	CPL PREP			;kade 2sec.zmna obrazovky
TED_NE:
	MOV R1,#0			;nulovn indexu bytu
	MOV R0,#SDATA		;adresa SDATA do R0
DALSI_BYTE:
	MOV A,@R0			;byte z bufferu do A
	INC R0			;inkrementace adresy bufferu
	INC R1			;inkrementace indexu bytu
	ACALL PREV			;pevod hodnoty do znaku
	CJNE R1,#1,DRUHY		;neni 1.byte = dal
	MOV RADEK1+6,R3
	MOV RADEK1+7,R2
	JMP DALSI_BYTE
DRUHY:
	CJNE R1,#2,TRETI		;neni 2.byte = dal
	MOV RADEK1+12,R3		;
	MOV RADEK1+13,R2		;
	JMP DALSI_BYTE
TRETI:
	CJNE R1,#3,CTVRTY	;neni 3.byte = dal
	MOV RADEK2+12,R3		;
	MOV RADEK2+13,R2		;
	JMP DALSI_BYTE
CTVRTY:
	CJNE R1,#4,PATY		;neni 4.byte = dal
	MOV RADEK2+7,R3		;
	MOV RADEK2+8,R2		;
	JMP DALSI_BYTE
PATY:
	MOV RADEK1,R3		;
	MOV RADEK1+1,R2		;

	JB PREP,OBRAZ2		;kazde 2secundy se meni zobrazeni
	;psani textu 1
	mov	a,#10000000b	;nastav 1.radek,1.sloupec
	mov	b,#1
	acall	PosliInstr
	mov	dptr,#Text1	;ukazatel na zacatek textu 1
	mov	R7,#0	;nulovat ukazatel znaku
Text1dalsi:	mov	a,R7
	movc	a,@a+dptr	;nacti znak z pozice R7
	jz	Text1OK	;jestli je znak 0, tak je text kompletni
	mov	b,#1
	acall	PosliData
	inc	R7	;dalsi znak
	jmp	Text1dalsi	;pis dalsi
Text1OK:	
	;psani dat 1
	mov	a,#11000000b	;nastav 2.radek,1.sloupec
	mov	b,#1
	acall	PosliInstr
	mov	R0,#RADEK1	;adresa dku do R0
	mov	R1,#0		;nulovn indexu bytu
Data1dalsi:	mov	a,@R0
	mov	b,#1
	acall	PosliData
	inc	R0	;dalsi znak
	inc	R1
	cjne	R1,#16,Data1dalsi	;pis dalsi
	jmp	SMYCKA
OBRAZ2:		
	;psani textu 2
	mov	a,#10000000b	;nastav 1.radek,1.sloupec
	mov	b,#1
	acall	PosliInstr
	mov	dptr,#Text2	;ukazatel na zacatek textu 2
	mov	R7,#0	;nulovat ukazatel znaku
Text2dalsi:	mov	a,R7
	movc	a,@a+dptr	;nacti znak z pozice R7
	jz	Text2OK	;jestli je znak 0, tak je text kompletni
	mov	b,#1
	acall	PosliData
	inc	R7	;dalsi znak
	jmp	Text2dalsi	;pis dalsi
Text2OK:	
	;psani dat 2
	mov	a,#11000000b	;nastav 2.radek,1.sloupec
	mov	b,#1
	acall	PosliInstr
	mov	R0,#RADEK2	;adresa dku do R0
	mov	R1,#0		;nulovn indexu bytu
Data2dalsi:	mov	a,@R0
	mov	b,#1
	acall	PosliData
	inc	R0	;dalsi znak
	inc	R1
	cjne	R1,#16,Data2dalsi	;pis dalsi
	jmp	SMYCKA
	;tady jsou zobrazovane texty a jsou zakonceny 0
Text0:     db   'Kotel VIADRUS V1',0 ;textovy radek 0 
Text1:	db	'V_ref V_out V_in',0 ;textovy radek 1 
;			'XXC  XXC  XXC'   ;datovy radek 1
Text2:	db	'Podlaha REF OUT ',0 ;textovy radek 2 
;			'       XXC XXC'   ;datovy radek 2	
	;podprogram "posli data na displej"
PosliData:	setb	RS	;RS na log.1 - zapis dat
	acall	PosliSpol	;posli displeji
	ret
	;podprogram "posli instrukci displeji"
PosliInstr:	clr	RS	;RS na log.0 - zapis instrukce
	acall	PosliSpol	;posli displeji
	ret
	;vlastni vyslani bytu
PosliSpol:	setb	E
	mov	P1,a		;posli data na P1
	acall	Delay5	;ustal
	clr	E
	acall	Delay		;cekej
	ret
Delay:	mov	R6,#250	
Delayloop1: nop	
		nop
		nop
		nop
		nop	
	djnz	R6,Delayloop1
	djnz	b,Delay
	ret
Delay5:	mov R6,#6	;nastav as
	djnz R6,$	;3x6x50 ns=900 ns
	ret	
	
PREV:	;vstup hodnoty v "A"
	ANL A,#11111110b	;vymaskovn nejniho bitu
	RR A			;/2=pevod na C	
	;jednotky:
	MOV B,#10	;dlen 10
	DIV AB	;dlen
	XCH A,B	;A-zbytek, B-podl
	PUSH B	;uchovej podl
	ADD A,#'0'	;pevod na znak
	MOV R2,A	;jednotky do R2
	POP ACC	;A-podl
	;destky:
	ADD A,#'0'	;pevod na znak
	MOV R3,A	;destky do R3
	RET	
	;obsluha peruen od UART:	
SERIAL:		
	;pjem:
	MOV A,SBUF			;pijmi data
     	MOV @R0,A			;ulo do zsobnku
	INC R1			;zvy potadlo
	INC R0			;zvy adresu
	CJNE R1,#SMAX,NAVRAT	;test konce zprvy
	SETB KONEC_PRIJMU	;povol vysln zprvy
NAVRAT: CLR RI			;nulovn indiktoru vysln 
	RETI				;nvrat z peruen

	end