; Program pro LCD display 2x16 znaku V1.0
; Klid na lince pro max DPTR (65535) cca 60ms

DPL	DATA	82H
DPH	DATA 	83H
PCON	DATA	87H
TMOD	DATA	89H
P1	DATA	90H
TCONB	DATA	91H
RL0	DATA	92H
RL1	DATA	93H
RH0	DATA	94H
RH1	DATA	95H
SCON	DATA	98H
SBUF	DATA	99H
P3	DATA	0B0H
P1M0	DATA	0C2H
P1M1	DATA	0C3H
P3M0	DATA	0C6H
P3M1	DATA	0C7H
ACC	DATA	0E0H
B	DATA	0F0H

TR1	BIT	8EH
RI	BIT	98H
ES	BIT	0ACH
EA	BIT	0AFH

RESETADDR	EQU	0000H
SERADDR	EQU	0023H
E	equ	P3.7
RS	equ	P3.5
CISLO equ	40H
RADEK1 equ	50H		;1.datov dek
RADEK2 equ	60H		;2.datov dek
KONEC_PRIJMU BIT 1	;nvrat na zatek cyklu
PREP BIT 2
DATA_IN BIT 3
SKONST EQU 65484		;pro 9600 Bd

	ORG RESETADDR	;reset
	JMP RESET	
	ORG SERADDR		;obsluha UART
	JMP SERIAL	

RESET:	;inicializace:	
	MOV P1M0,#00000000B	;P1 vstupy
	MOV P1M1,#11111111B	;
	MOV P3M0,#00000001B	;P3 vstupy
	MOV P3M1,#11111110B	;P3.0 vstup RxD
	mov	P1,#255
	mov	P3,#255
	MOV TMOD,#00010001B	;16b asova 0 a 1
	SETB TR1			;spus asova 1
	MOV RL1,#LOW SKONST	;nastav penos.
	MOV RH1,#HIGH SKONST	;rychlost
	MOV SCON,#01010000B	;8b async. reim+povolen pjmu
	MOV PCON,#00000000B	;SMOD1=0
	SETB EA			;uvolni peruen
	SETB ES			;povol peruen od UART
	clr	E
	clr 	KONEC_PRIJMU
	mov	b,#150		;x100 us
	call	Delay			;zpozdeni nez disp. po pripojeni napajeni muze 						 prijimat data
	;inicializace
	mov	a,#00111000b	;8-bit mod, font 5x7 a dvouradkovy disp.
	mov	b,#1			;nastaven prodlevy 40uS
	acall	PosliInstr
	mov	a,#00000110b	;posuv kurzoru vpravo, a text se neposouva
	mov	b,#1
	acall	PosliInstr
	mov	a,#00001100b	;zapnout disp., vypnout kurzor
	mov	b,#1
	acall	PosliInstr
	mov	a,#00000001b	;smaz displej a vrat kurzor na zacatek
	mov	b,#17			;nastaven prodlevy 1,64mS
	acall	PosliInstr

	;psani uvodniho textu
	mov	a,#10000000b	;nastav 1.radek,1.sloupec
	mov	b,#1
	acall	PosliInstr
	mov	dptr,#Text0	;ukazatel na zacatek textu 0
	mov	R7,#0			;nulovat ukazatel znaku
Text0dalsi:
	mov	a,R7
	movc	a,@a+dptr		;nacti znak z pozice R7
	jz	Text0OK		;jestli je znak 0, tak je text kompletni
	mov	b,#1
	acall	PosliData
	inc	R7			;dalsi znak
	jmp	Text0dalsi		;pis dalsi
Text0OK:	

SMYCKA:
	CLR DATA_IN
	CLR PREP
	MOV DPTR,#0
CEKAM:		
	INC DPTR			;inkrementace DPTR
	MOV A,DPL			;spodni byte DPTR
	JNZ TEST
	MOV A,DPH			;horn byte DPTR
	JNZ TEST
	JMP LINKA
TEST:
	MOV C,DATA_IN
	JC SMYCKA
	JMP CEKAM
LINKA:
	MOV R1,#0			;vynuluj potadlo byt
	MOV R0,#RADEK1		;adresa RADEK1 do R0
	JNB KONEC_PRIJMU,$	;cel zprva = zobrazen dat
	CLR KONEC_PRIJMU		;vynuluj pznak konce pjmu
	MOV R1,#0			;nulovn indexu bytu
	MOV R0,#RADEK1		;adresa SDATA do R0
	;zapis dat 1
	mov	a,#10000000b	;nastav 2.radek,1.sloupec
	mov	b,#1
	acall	PosliInstr
	mov	R0,#RADEK1	;adresa dku do R0
	mov	R1,#0		;nulovn indexu bytu
Data1dalsi:	mov	a,@R0
	mov	b,#1
	acall	PosliData
	inc	R0	;dalsi znak
	inc	R1
	cjne	R1,#16,Data1dalsi	;pis dalsi
	;zapis dat 2
	mov	a,#11000000b	;nastav 2.radek,1.sloupec
	mov	b,#1
	acall	PosliInstr
	mov	R0,#RADEK2	;adresa dku do R0
	mov	R1,#0		;nulovn indexu bytu
Data2dalsi:	mov	a,@R0
	mov	b,#1
	acall	PosliData
	inc	R0	;dalsi znak
	inc	R1
	cjne	R1,#16,Data2dalsi	;pis dalsi
	jmp	SMYCKA

	;uvodni text zakonceny 0
Text0:     db   ' VITEJ NA LCD   ',0 ;textovy radek 

	;podprogram "posli data na displej"
PosliData:	setb	RS		;RS na log.1 - zapis dat
		acall	PosliSpol	;posli displeji
		ret

	;podprogram "posli instrukci displeji"
PosliInstr:	clr	RS		;RS na log.0 - zapis instrukce
		acall	PosliSpol	;posli displeji
		ret

	;vlastni vyslani bytu
PosliSpol:	setb	E
	mov	P1,a		;posli data na P1
	acall	Delay5	;ustal
	clr	E
	acall	Delay		;cekej
	ret

Delay:	mov	R6,#250	
Delayloop1: nop	
		nop
		nop
		nop
		nop	
		djnz	R6,Delayloop1
		djnz	b,Delay
		ret

Delay5:	mov R6,#6	;nastav as
		djnz R6,$	;3x6x50 ns=900 ns
		ret	
	
	;obsluha peruen od UART:	
SERIAL:		
	;pjem:
	SETB DATA_IN		;pro kontrolu klidu na lince
	JB PREP,DRUHY_R
	MOV A,SBUF			;pijmi data
     	MOV @R0,A			;ulo do RADEK1
	INC R1			;zvy potadlo
	INC R0			;zvy adresu
	CJNE R1,#16,NAVRAT	;test konce zprvy
	MOV R1,#0			;vynuluj potadlo byt
	MOV R0,#RADEK2		;adresa SDATA do R0
	SETB PREP
	JMP NAVRAT
DRUHY_R:
	MOV A,SBUF			;pijmi data
     	MOV @R0,A			;ulo do RADEK2
	INC R1			;zvy potadlo
	INC R0			;zvy adresu
	CJNE R1,#16,NAVRAT	;test konce zprvy
	SETB KONEC_PRIJMU		;povol zobrazeni zprvy
NAVRAT: CLR RI			;nulovn indiktoru prijmu 
	RETI				;nvrat z peruen

	end